#ifndef _FRAKTAL_H
#define _FRAKTAL_H

#include <windows.h>
#include "resource.h"
#include "cmplx.h"
#include "mc.h"
#include "farbe.h"
#include "punkt.h"

#define XSIZE 300	//Groesse des Bildes in Pixeln
#define YSIZE 300
#define X true		//Typ der umzurechnenden Koordinaten
#define Y false

class Fraktal
{
private:
	int			m_Iterationen;
    int			m_Exponent;
	bool		m_isMandel;						//Mandelbrot- oder Juliamenge?
	int			m_Zoomfaktor;

	double		m_Aufloesung;					//Abstand zum Rand
	double		m_JuliaAufloesung;
   	double		m_Relationsfaktor;

	void		SetColor(int i, int x, int y);	//Pixelfarbe ermitteln und setzen

public:
	COLORREF	m_Fraktalbild[XSIZE][YSIZE];	//Speicherort fuer das Bild
	Punkt		m_Mittelpunkt;		
	Punkt		m_JuliaMittelpunkt;
	MonteCarlo	m_MC;

	Farbe		m_Col_Menge;	//Farben
	Farbe		m_Col_Lower;
	Farbe		m_Col_Upper;

	Fraktal();

	int		getIterationen()		{return m_Iterationen;}
	void	setIterationen(int it)	{m_Iterationen = it;}
	
	int		getExponent()			{return m_Exponent;}
	void	setExponent(int exp)	{m_Exponent = exp;}
	
	bool	isMandel()				{return m_isMandel;}
	void	setIsMandel(bool isM)	{m_isMandel = isM;}

	int		getZoomfaktor()			{return m_Zoomfaktor;}
	void	setZoomfaktor(int zoom)	{m_Zoomfaktor = zoom;}

	double	getAufloesung()
	{
		if(m_isMandel == true)	return m_Aufloesung;
		else					return m_JuliaAufloesung;
	}
    void	setAufloesung(double a)	
	{
		if(m_isMandel == true)	m_Aufloesung = a;
		else					m_JuliaAufloesung = a;								
	}

	double	ScreenToMB(double Mittelpunkt, int xyScreen, bool xORy);



	double	Betrag(cmplx c);					//Betrag einer komplexen Zahl
	cmplx	Multiplikation(cmplx c, cmplx d);	//Multiplikation komplexer Zahlen

	void	CalcRelations();
	void	CreatePic(HWND hDlg);				//Bild herstellen
	int		Iterationsschleife(cmplx C, cmplx Z);
};

#endif