#include "main.h"

void StartCalculation(HWND hDlg)
{
	Menge.m_MC.ResetTreffer();
	Menge.CalcRelations();
	Menge.CreatePic(hDlg);
}

void DrawFraktal(HWND hWndPaintBox)
{
	InvalidateRect(hWndPaintBox, 0, 0);

	hdc = BeginPaint(hWnd, &ps);
	UpdateWindow (hWndPaintBox) ;
	hdc = GetDC (hWndPaintBox);
	
	for(int y=0; y<YSIZE; y++)
	{
		for(int x=0; x<XSIZE; x++)
			SetPixel(hdc, x, y, Menge.m_Fraktalbild[x][y]);
	}
	
	ReleaseDC (hWndPaintBox, hdc);
	EndPaint(hWnd, &ps);
};


void FillDialog(HWND hDlg)
{
	SetDlgItemInt(hDlg, ID_MAXIT, Menge.getIterationen(), true);
	SetDlgItemInt(hDlg, ID_EXPONENT, Menge.getExponent(), true);
	SetDlgItemInt(hDlg, ID_ZOOMFAKTOR, Menge.getZoomfaktor(), true);

	sprintf(schrift, "%.17f", Menge.m_Mittelpunkt.getRe());
	SetDlgItemText(hDlg, ID_MITTE_RE, schrift);
	sprintf(schrift, "%.17f", Menge.m_Mittelpunkt.getIm());
	SetDlgItemText(hDlg, ID_MITTE_IM, schrift);

	sprintf(schrift, "%.20f", Menge.getAufloesung());
	SetDlgItemText(hDlg, ID_AUFLOES, schrift);

	SetDlgItemInt(hDlg, ID_MC_GESAMT, Menge.m_MC.getGesamt(), true);
	SetDlgItemInt(hDlg, ID_MC_TREFFER, Menge.m_MC.getTreffer(), true);
		
	sprintf(schrift, "%.3f %%", Menge.m_MC.getAnteil());
	SetDlgItemText(hDlg, ID_MC_ANTEIL, schrift);

	if(Menge.isMandel() == true) {SendMessage(GetDlgItem(hDlg, ID_MANDEL), BM_SETCHECK, 1,0L);}
	if(Menge.isMandel() == false) {SendMessage(GetDlgItem(hDlg, ID_JULIA), BM_SETCHECK, 1,0L);}
};

void GetDlgValues(HWND hDlg)
{
	Menge.setIterationen(GetDlgItemInt(hDlg, ID_MAXIT, NULL, true));
	Menge.setExponent(GetDlgItemInt(hDlg, ID_EXPONENT, NULL, true));
	Menge.setZoomfaktor(GetDlgItemInt(hDlg, ID_ZOOMFAKTOR, NULL, true));

    GetDlgItemText(hDlg, ID_MITTE_RE, schrift, sizeof(schrift));
	Menge.m_Mittelpunkt.setRe(atof(schrift));
	GetDlgItemText(hDlg, ID_MITTE_IM, schrift, sizeof(schrift));
	Menge.m_Mittelpunkt.setIm(atof(schrift));

	GetDlgItemText(hDlg, ID_AUFLOES, schrift, sizeof(schrift));
	Menge.setAufloesung(atof(schrift));
	
	if(BST_CHECKED == SendDlgItemMessage(hDlg, ID_MANDEL, BM_GETCHECK, 0, 0))
	{Menge.setIsMandel(true);} else {Menge.setIsMandel(false);}

	Menge.CalcRelations();
}

void Zoom(bool isIn, HWND hDlg, HWND hPaint)
{
	GetDlgValues(hDlg);
	if(isIn == true)
		Menge.setAufloesung(Menge.getAufloesung() / Menge.getZoomfaktor());
	else
		Menge.setAufloesung(Menge.getAufloesung() * Menge.getZoomfaktor());
	
	StartCalculation(hDlg);
	FillDialog(hDlg);
	DrawFraktal(hPaint);
}

void Update(HWND hDlg, HWND hPaint)
{
	GetDlgValues(hDlg);
	StartCalculation(hDlg);
	DrawFraktal(hPaint);
	FillDialog(hDlg);
}